import { VersionSelectors } from '@pnpm/resolver-base';
import { PackageManifest } from '@pnpm/types';
import { RegistryPackageSpec } from './parsePref';
export interface PackageMeta {
    'dist-tag': {
        [name: string]: string;
    };
    versions: {
        [name: string]: PackageInRegistry;
    };
    cachedAt?: number;
}
export interface PackageMetaCache {
    get(key: string): PackageMeta | undefined;
    set(key: string, meta: PackageMeta): void;
    has(key: string): boolean;
}
export declare type PackageInRegistry = PackageManifest & {
    dist: {
        integrity?: string;
        shasum: string;
        tarball: string;
    };
};
export declare type PickPackageOptions = {
    authHeaderValue?: string;
    preferredVersionSelectors: VersionSelectors | undefined;
    registry: string;
    dryRun: boolean;
};
declare const _default: (ctx: {
    fetch: (pkgName: string, registry: string, authHeaderValue?: string | undefined) => Promise<PackageMeta>;
    metaFileName: string;
    metaCache: PackageMetaCache;
    storeDir: string;
    offline?: boolean | undefined;
    preferOffline?: boolean | undefined;
}, spec: RegistryPackageSpec, opts: PickPackageOptions) => Promise<{
    meta: PackageMeta;
    pickedPackage: PackageInRegistry | null;
}>;
export default _default;
